<template>
	<el-autocomplete trigger-on-focus placeholder="Contexto" style="width:100%"
		v-model="contexto" value-key="context"
		:fetch-suggestions="filtrarContextos" :size="size"
	></el-autocomplete>	
</template>
<script>
import {Rest} from '@/../modules/mind-core-vue'
export default {
	props: {
		value: String,
		filter: String,
		size: String,
	},
	async created() {
		this.api = new Rest({
			uri: `api/ami/config-files/extensions.conf/categories`, 
			})
			this.loading = true;
			this.listaContextos = await this.api.FetchAll().catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
			this.listaContextos.sort()
			this.loading = false;
	},
	computed: {
		contexto:{
			get(){
				return this.value
			},
			set(v){
				this.$emit('input',v)
			}
		},
	},
	methods: {
		filtrarContextos(query, cb) {
			let res = []

			let contextos = this.listaContextos.filter(item => {
				const i = item.toLowerCase()
				const q = query.toLowerCase()
				const f = this.filter.toLowerCase()
				if(q && f) {
					return i.indexOf(q) >= 0 && i.indexOf(f) >= 0
				} 
				if(q) {
					return i.indexOf(q) >= 0
				}
				if(f) {
					return i.indexOf(f) >= 0
				}
				return true
			});
			for(const c of contextos) {
				res.push({context: c})
			}

			cb(res)
		},

	},
	data(){
		return {
			listaContextos: []
			// placeholder: "Parámetros",
		}
	}
	
}
</script>
<style  scoped>
	.dialplan-action .padding-right {
			padding-right: 15px;
	}
	.dialplan-action .font-fixed input{
		font-family: "Lucida Console";
		color: #4958a8;
	}
	.font-fixed input{
		font-family: "Lucida Console";
		color: #4958a8;
	}

</style>
<style lang="css">
</style>